// 画像をW×Hの文字で表現する
(function(){
	// サイズ
	var w = 64;
	var h = 64;
	// 文字で輝度を表現する
	var chr = [ "　","．","・","＋","％","＃","＊","■"];
	var imgFile = File.openDialog("画像ファイルを選択してください", "*");
	if(!imgFile){ return; }	// キャンセルされたら何もしない
	var ascFile = File.saveDialog("保存するテキストファイル名を入れてください");
	if (!ascFile){ return; }
	var flag = ascFile.open("w");	// 書き込みモードで開く
	if (!flag){
		alert("ファイルが書き込めないようです");
		return;
	}
	ascFile.encoding = "utf-8";
	preferences.rulerUnits = Units.PIXELS;	// 単位をピクセルに設定
	app.open(imgFile);
	var docObj = app.activeDocument;
	docObj.resizeImage(w, h);	// 指定されたサイズにする
	docObj.changeMode (ChangeMode.GRAYSCALE);
	for(var y=0; y<h; y++){
		var txt = "";
		for(var x=0; x<w; x++){
			// ピクセル輝度を読み出し文字数で除算
			var g = Math.floor(getPixel(x,y) / (256/chr.length));
			txt = txt + chr[g];	// 対応する文字を連結
		}
		ascFile.writeln(txt);
	}
	docObj.close(SaveOptions.DONOTSAVECHANGES);
	//---------------------------------------------
	// ピクセルの輝度を取得する(8bitモード専用)
	//---------------------------------------------
	function getPixel(x,y){
		docObj.selection.select([[x,y],[x+1,y],[x+1,y+1],[x,y+1],[x,y]]);
		var data = docObj.channels[0].histogram;
		for (var i=0; i<256; i++) { if (data[i] > 0) return i; }
	}
})();

